"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var iso3166 = require("iso3166-1");
var got_1 = require("got");
var fs = require("fs");
var union_1 = require("@turf/union");
var simplify_1 = require("@turf/simplify");
function wait(delayMs) {
    if (delayMs === void 0) { delayMs = 1000; }
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new Promise(function (resolve) { return setTimeout(resolve, delayMs); })];
        });
    });
}
function update() {
    var _a, _b, _c;
    return __awaiter(this, void 0, void 0, function () {
        var countryList, countryMap, i, len, country, data, raw, acceptedTypes, merged, simple;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    countryList = iso3166.list();
                    countryMap = {};
                    i = 0, len = countryList.length;
                    _d.label = 1;
                case 1:
                    if (!(i < len)) return [3 /*break*/, 5];
                    country = countryList[i];
                    console.log(new Date().toString() + ": Get " + country.alpha2 + ", " + (i + 1) + " of " + len);
                    return [4 /*yield*/, got_1.default('https://nominatim.openstreetmap.org/search', {
                            searchParams: "q=" + country.alpha2 + "&format=geojson&countrycodes=" + country.alpha2.toLowerCase() + "&polygon_geojson=1&limit=1&extratags=1&namedetails=1",
                            headers: {
                                'Referer': 'https://github.com/grinat/osm-countries-bounds.git',
                            },
                            responseType: 'json',
                        })];
                case 2:
                    data = _d.sent();
                    raw = data.body;
                    if (!raw.features.length) {
                        console.log(country.alpha2 + " skipped, no poly, https://wikipedia.org/wiki/" + encodeURIComponent((_c = (_b = (_a = raw.features[0]) === null || _a === void 0 ? void 0 : _a.properties) === null || _b === void 0 ? void 0 : _b.extratags) === null || _c === void 0 ? void 0 : _c.wikipedia));
                        return [3 /*break*/, 4];
                    }
                    try {
                        acceptedTypes = ['MultiPolygon', 'Polygon'];
                        if (acceptedTypes.indexOf(raw.features[0].geometry.type) === -1) {
                            console.log(country.alpha2 + " not a accepted feature type(has " + raw.features[0].geometry.type + " need one of " + acceptedTypes.join(',') + "), https://wikipedia.org/wiki/" + encodeURIComponent(raw.features[0].properties.extratags.wikipedia));
                            return [3 /*break*/, 4];
                        }
                        merged = void 0;
                        if (raw.features.length > 1) {
                            merged = union_1.default.apply(void 0, raw.features);
                        }
                        else {
                            merged = raw.features[0];
                        }
                        simple = simplify_1.default(merged, {
                            tolerance: 0.02,
                            highQuality: true,
                        });
                        raw.features = [simple];
                        raw.features[0].properties.namedetails = {
                            name: raw.features[0].properties.namedetails.name,
                            'name:en': raw.features[0].properties.namedetails['name:en'],
                        };
                    }
                    catch (e) {
                        console.log("Error in " + country.alpha2 + ": " + e.toString());
                        console.error(e);
                    }
                    countryMap[country.alpha2] = raw;
                    fs.writeFileSync('list.json', JSON.stringify(countryMap, null, ' '));
                    return [4 /*yield*/, wait()];
                case 3:
                    _d.sent();
                    _d.label = 4;
                case 4:
                    i++;
                    return [3 /*break*/, 1];
                case 5:
                    console.log("Done, added " + Object.keys(countryMap).length + " countries of " + countryList.length);
                    return [2 /*return*/];
            }
        });
    });
}
update();
//# sourceMappingURL=update-list.js.map